using System;
using System.IO;
using System.Text;

namespace Carobnjak
{
    internal class Program
    {
        static int moc = 0;
        static int[] NewArray(int n, int[] moci, int i)
        {
            int[] moci_copy = new int[n];
            Array.Copy(moci, 0, moci_copy, 0, n);
            int temp = moci_copy[i];
            for(++i; i < n - 1; i++)
            {
                moci_copy[i] = moci_copy[i + 1];
            }
            moci_copy[n - 1] = temp;
            Array.Resize(ref moci_copy, n - 1);
            return moci_copy;
        }

        static int Nizovi(int n, int k, int[] moci)
        {
            if(n - k > 0)
            {
                for(int i = 0; i < n; i++)
                {
                    int x = Nizovi(n - 1, k + 1, NewArray(n, moci, i));
                    if (x > moc) moc = x;
                }
            }
            else
            {
                return KonacnaMoc(n, moci);
            }
            return moc;
        }

        static int KonacnaMoc(int n, int[] moci)
        {
            int[] moci_copy1 = new int[n];
            Array.Copy(moci, 0, moci_copy1, 0, n - 1);
            moci_copy1[0] = moci[0] - moci[n - 1];
            int[] moci_copy2 = new int[n];
            Array.Copy(moci, 1, moci_copy2, 0, n - 1);
            moci_copy2[n - 1] = moci[n - 1] - moci[0];
            if ((n - 1) > 1)
            {
                int x = KonacnaMoc(n - 1, moci_copy1);
                int y = KonacnaMoc(n - 1, moci_copy2);
                return x >= y ? x : y;
            }
            return moci_copy1[0] >= moci_copy2[0] ? moci_copy1[0] : moci_copy2[0];
        }

        static void Main(string[] args)
        {
            Console.SetIn(new StreamReader(Console.OpenStandardInput(), Encoding.UTF8, false, 11199992));
            string[] values = Console.ReadLine().Split(' ');
            int n = Convert.ToInt32(values[0]);
            int k = Convert.ToInt32(values[1]);
            string[] moci_unos = Console.ReadLine().Split(' ');
            int[] moci = new int[n];
            for(int i = 0; i < n; i++)
            {
                moci[i] = Convert.ToInt32(moci_unos[i]);
            }
            Console.Write(Nizovi(n, k, moci));
        }
    }
}